/****************************************************************************/
/*     H  E  L  P  .  H
**
** Tekij:         Vesa Lappalainen 6.12.1993
** Muutettu:
** Mit muutettu:
**
** Tarkoituksena on, ett avustukset voidaan kirjoittaa tiedostoon
** ohjelma.HLP, joka on muotoa:
**
**   [PMENU]
**   ; Kommenttirivi jossa voi olla mit vaan eik tulostu
**   Pmenusta voit valita ...
**   ...
**   [TULOSTUS]
**   Tulostus on ...
**   ...
**   # ; tarkoittaa nytn pysyttmist.
**   Tulostus menee...
**   ...
**   [LIS UUSI]
**   Listn uusi ...
**   [t_ok]# ; jos hakasulun perss on jokin merkki, ei tm
**   ;         otsikko lydy *-etsimisell.
**   Tarkistus tekee sit ja tt
**   [SISLLYS] ; Tm olisi aina hyv olla!
**   Sisllys:
**   ...
**
**
** Avustustiedoston aihenimien "case" ei vaikuta, eli [PMenu] == [PMENU]
**
** Aliohjelmat:
**    alusta_help            - alustaa help-systeemin valitulle ohjelmalle
**    vapauta_help           - lopettaa helpin kytn
**    help                   - tulostaa valitun help-tekstin jos
**                             aihe hakasuluissa.  Jollei ole, tulostetaan
**                             kutsuparametri sellaisenaan
**    help_aihe              - tulostaa valitun teksin.  Jos teksti
**                             ei ole hakasuluissa, listn ne
**    help_hakemisto         - helpin selailutilaan valitun aiheen kohdalta
**                             tarvittaessa listn aiheeseen hakasulut
**
**
** Kytt:
**   Ohjelmoijan on ennen helpin kyttmist kutsuttava (mys avustus
**   tiedoston vaihtamiseksi):
**
**     alusta_help("Oma"); // alustaa help-tiedoston Oma.HLP
**
**   Kun helpi ei en tarvita pit kutsua (uusi alusta_help vapauttaa
**   edellisen automaattisesti).
**
**     vapauta_help();
**
**   Kun halutaan avustusta esimerkiksi aiheesta TULOSTUS, kutsutaan
**
**     help("[TULOSTUS]");
**
**   Aihe voi olla mys jokereita sisltv (esim. [TUL*]).  Jos aihe
**   on NULL, aloitetaan sisllysluettelosta pyrittminen
**
**   Jotta helpi olisi mahdollista kytt samanlaisena mys ohjelman
**   sisisille teksteille, voidaan kutsua
**
**     help("Valittava jotakin\n");
**
**   joka tulostaa helppimisesti lainausmerkeiss oleva tekstin.
**   Eli jos teksti ei ala [ tulostetaan teksti sellaisenaan.
**
**   Jos hakasulkuja ei haluta kirjoittaa aiheen ymprille kutsussa,
**   voidaan kytt muotoa
**
**     help_aihe("Tulostus"); // Lis tarvittaessa hakasulut
**
**   Helpissa voidaan kytt mys hakuohjelmaa kutsulla
**
**     help_hakemisto("[TULOSTUS]"); // Aloittaa rivilaskurin alusta!
**
**   jolloin aloitetaan tulostamalla tulostksen ohjeet ja kysytn
**   hakusanaa.  Hakasulut listn tarvittaessa.
**
**   Jos tulee paljon help() - tulostuksia samaan kasaan, kannattaa
**   aluksi kutsua
**
**     alusta_help_rivit()
**
**   jotta pysytyslaskuri saadaan aloittamaan alusta.
**
**   C++ kytss riitt kirjoittaa cHelp help("oma");
**   koska vapauta_help kutsutaan sitten automaattisesti helpin
**   hvittjss
*/
#ifndef HELP_H
#define HELP_H

#define HELP_STOP_JONO "#"
#define HELP_JONO      "?"

#ifdef __cplusplus
extern "C" {
#endif


int help(const char *);
int help_aihe(const char *);
int help_hakemisto(const char *);

int alusta_help(const char *);
void vapauta_help(void);

void alusta_help_rivit(void);

#ifdef __cplusplus
#include <string>
class cHelp {
public:
  cHelp(const char *s=NULL)           { if ( s != NULL ) alusta_help(s);  }
  cHelp(const std::string &s)         { alusta(s);                        }
  ~cHelp()                            { vapauta_help();                   }
  void alusta(const std::string &s)   { alusta_help(s.c_str());           }
  int help(const char *s)             { return ::help(s);                 }
  int help(const std::string &s)      { return ::help(s.c_str());         }
  int aihe(const char *s)             { return help_aihe(s);              }
  int aihe(const std::string &s)      { return help_aihe(s.c_str());      }
  int hakemisto(const char *s=NULL)   { return help_hakemisto(s);         }
  int hakemisto(const std::string &s) { return help_hakemisto(s.c_str()); }
  void alusta_rivit(void)             { alusta_help_rivit();              }
};

}
#endif

#endif
